<script>
  import {onMount} from 'svelte'

  import Settings from "./_design_1_settings.svelte"; 
  import Plot1 from "./_design_1_plot1.svelte"; 
  import Plot2 from "./_design_1_plot2.svelte" 
  import {json} from "d3-fetch";
  import {extent} from 'd3-array';
  
  // declare variables
  $: initial = ["Baltimore","within building type"];
  $: city = initial[0];
  $: scaling = initial[1];

  let heatingdata = null 
  let data_working = {} 
  let range = {} 

  // Importing data from json file
  onMount(async () => {

    heatingdata = await json('/data/hourly_heating_december.json')
    heatingdata.forEach((x)=>{
      if (!(x.city in data_working)){
        data_working[x.city]={}
      }
      if (!(x.buildingtype in data_working[x.city])){
        data_working[x.city][x.buildingtype]=[]
      }
      data_working[x.city][x.buildingtype].push(x.total_heating_energy)

      if (!(x.city in range)){
        range[x.city]={}
      }
      if (!(x.buildingtype in range[x.city])){
        range[x.city][x.buildingtype]={'min':null, 'max':null}
      }
      range[x.city][x.buildingtype]['min']=extent(data_working[x.city][x.buildingtype])[0]
      range[x.city][x.buildingtype]['max']=extent(data_working[x.city][x.buildingtype])[1]
      })
  })

$: data_city=data_working[city]
$: cityrange=range[city]


function MaxVals(input){
  let max_city=0
  Object.keys(input).forEach((key)=>{
    if(input[key]['max']>max_city){max_city=input[key]['max']}
  })
  return max_city
}
function MinVals(input){
  let min_city=0
  Object.keys(input).forEach((key)=>{
    if(input[key]['min']<min_city){min_city=input[key]['min']}
  })
  return min_city
}

</script>

 
<div align-items="baseline;">
<Settings bind:initial={initial}/>
{#if scaling=="within building type"}
  <Plot1 data_working={data_city} {cityrange}/>
{:else}
  <Plot2 data_working={data_city} max_city={MaxVals(cityrange)} min_city={MinVals(cityrange)}/>
{/if}
</div>
